<template>
    <table class="table-auto font-sans shadow">
        <thead class="rounded-r-lg">
            <tr class="bg-indigo-900 text-white uppercase">
                <th v-for="header in this.headers" @click="sort(header.key)" class="p-3">
                    {{ header.label }}
                    <svg xmlns="http://www.w3.org/2000/svg" class="h-5 w-5 inline" viewBox="0 0 20 20" fill="currentColor">
                        <path fill-rule="evenodd" d="M5.293 7.293a1 1 0 011.414 0L10 10.586l3.293-3.293a1 1 0 111.414 1.414l-4 4a1 1 0 01-1.414 0l-4-4a1 1 0 010-1.414z" clip-rule="evenodd" />
                    </svg>
                </th>
            </tr>
        </thead>
        <transition-group name="flip-list" tag="tbody">
            <tr v-for="rowData in formattedData" v-bind:key="rowData[0]" class="text-gray-500 hover:bg-indigo-200">
                <td class="p-3" v-for="field in rowData">{{ field }}</td>
            </tr>
        </transition-group>
    </table>
</template>
<script>
    export default {
        data () {
            return {
                accumulator: []
            }
        },
        props: ['headers', 'data'],
        computed: {
            formattedData: function () {
                let keys = this.headers.map((item) => {
                    return item.key
                });
                this.accumulator = this.data.reduce((acc, key) => {
                    acc.push(
                        keys.map((item) => {
                            return key[item]
                        })
                    );
                    return acc;
                }, []);
                return this.accumulator
            }
        },
        methods: {
            sort(value) {
                 this.data.sort(function (a, b) {
                     if (a[value].toLowerCase() > b[value].toLowerCase()) return 1;
                     if (a[value].toLowerCase() < b[value].toLowerCase()) return -1;
                     return 0;
                 });
            },
        },
        created() {

        },
    }
</script>
